XdkWrl: ElevationGrid Class Reference

Home | Hierarchy | Members | Alphabetical | Related Pages

# ElevationGrid Class Reference
[Standard Node Types]

`#include <elevationgrid.h>`

Inherits Node.

List of all members.

## Public Member Functions
| ElevationGrid (const char *name="")
virtual | ~ElevationGrid ()
virtual unsigned int | nbFields () const
virtual FieldHandle | field (const std::string &n)
virtual FieldHandle | field (unsigned int i)
virtual bool | isSetToDefaultValue (unsigned int i) const
virtual unsigned int | nbEventsIn () const
virtual EventInHandle | eventIn (const std::string &n)
virtual EventInHandle | eventIn (unsigned int i)
virtual unsigned int | nbEventsOut () const
virtual EventOutHandle | eventOut (const std::string &n)
virtual EventOutHandle | eventOut (unsigned int i)
const char * | typeName () const
virtual Node * | duplicate () const
virtual Node * | duplicate (std::map< const Node *, Node * > &) const
## Public Attributes
Exposed Fields
A field that is capable of receiving events via an eventIn to change its value(s), and generating events via an eventOut when its value(s) change.
SFNode | color
SFNode | normal
SFNode | texCoord
Fields
A property or attribute of a node. Each node type has a fixed set of fields. Fields may contain various kinds of data and one or many values. Each field has a default value.
MFFloat | height
SFBool | ccw
SFBool | colorPerVertex
SFFloat | creaseAngle
SFBool | normalPerVertex
SFBool | solid
SFInt32 | xDimension
SFFloat | xSpacing
SFInt32 | zDimension
SFFloat | zSpacing
Events In
EventIn< MFFloat > | set_height
EventIn< SFNode > | set_color
EventIn< SFNode > | set_normal
EventIn< SFNode > | set_texCoord
Events Out
EventOut< SFNode > | color_changed
EventOut< SFNode > | normal_changed
EventOut< SFNode > | texCoord_changed

## Detailed Description

Here is the documentation for this node type, from the ISO standard.

## 6.19 ElevationGrid

The ElevationGrid node specifies a uniform rectangular grid of varying height in the Y=0 plane of the local coordinate system. The geometry is described by a scalar array of height values that specify the height of a surface above each point of the grid.

The xDimension and zDimension fields indicate the number of elements of the grid height array in the X and Z directions. Both xDimension and zDimension shall be greater than or equal to zero. If either the xDimension or the zDimension is less than two, the ElevationGrid contains no quadrilaterals. The vertex locations for the rectangles are defined by the height field and the xSpacing and zSpacing fields:

- The height field is an xDimension by zDimension array of scalar values representing the height above the grid for each vertex.
- The xSpacing and zSpacing fields indicate the distance between vertices in the X and Z directions respectively, and shall be greater than zero.

Thus, the vertex corresponding to the point P[i, j] on the grid is placed at:

        P[i,j].x = xSpacing × i
        P[i,j].y = height[ i + j × xDimension]
        P[i,j].z = zSpacing × j

        where 0 <= i < xDimension and 0 <= j < zDimension,
        and P[0,0] is height[0] units above/below the origin of the local
        coordinate system

The set_height eventIn allows the height MFFloat field to be changed to support animated ElevationGrid nodes.

The color field specifies per-vertex or per-quadrilateral colours for the ElevationGrid node depending on the value of colorPerVertex. If the color field is NULL, the ElevationGrid node is rendered with the overall attributes of the Shape node enclosing the ElevationGrid node (see 4.14, Lighting model).

The colorPerVertex field determines whether colours specified in the color field are applied to each vertex or each quadrilateral of the ElevationGrid node. If colorPerVertex is FALSE and the color field is not NULL, the color field shall specify a Color node containing at least (xDimension-1)×(zDimension-1) colours; one for each quadrilateral, ordered as follows:

        QuadColor[i,j] = Color[ i + j × (xDimension-1)]

        where 0 <= i < xDimension-1 and 0 <= j < zDimension-1,
        and QuadColor[i,j] is the colour for the quadrilateral defined
            by height[i+j×xDimension], height[(i+1)+j×xDimension],
            height[(i+1)+(j+1)×xDimension] and height[i+(j+1)×xDimension]

If colorPerVertex is TRUE and the color field is not NULL, the color field shall specify a Color node containing at least xDimension × zDimension colours, one for each vertex, ordered as follows:

        VertexColor[i,j] = Color[ i + j × xDimension]

        where 0 <= i < xDimension and 0 <= j < zDimension,
        and VertexColor[i,j] is the colour for the vertex defined by
            height[i+j×xDimension]

The normal field specifies per-vertex or per-quadrilateral normals for the ElevationGrid node. If the normal field is NULL, the browser shall automatically generate normals, using the creaseAngle field to determine if and how normals are smoothed across the surface (see 4.6.3.5, Crease angle field).

The normalPerVertex field determines whether normals are applied to each vertex or each quadrilateral of the ElevationGrid node depending on the value of normalPerVertex. If normalPerVertex is FALSE and the normal node is not NULL, the normal field shall specify a Normal node containing at least (xDimension-1)×(zDimension-1) normals; one for each quadrilateral, ordered as follows:

        QuadNormal[i,j] = Normal[ i + j × (xDimension-1)]

        where 0 <= i < xDimension-1 and 0 <= j < zDimension-1,
        and QuadNormal[i,j] is the normal for the quadrilateral defined
            by height[i+j×xDimension], height[(i+1)+j×xDimension],
            height[(i+1)+(j+1)×xDimension] and height[i+(j+1)×xDimension]

If normalPerVertex is TRUE and the normal field is not NULL, the normal field shall specify a Normal node containing at least xDimension × zDimension normals; one for each vertex, ordered as follows:

        VertexNormal[i,j] = Normal[ i + j × xDimension]

        where 0 <= i < xDimension and 0 <= j < zDimension,
        and VertexNormal[i,j] is the normal for the vertex defined
            by height[i+j×xDimension]

The texCoord field specifies per-vertex texture coordinates for the ElevationGrid node. If texCoord is NULL, default texture coordinates are applied to the geometry. The default texture coordinates range from (0,0) at the first vertex to (1,1) at the last vertex. The S texture coordinate is aligned with the positive X-axis, and the T texture coordinate with positive Z-axis. If texCoord is not NULL, it shall specify a TextureCoordinate node containing at least (xDimension)×(zDimension) texture coordinates; one for each vertex, ordered as follows:

        VertexTexCoord[i,j] = TextureCoordinate[ i + j × xDimension]

        where 0 <= i < xDimension and 0 <= j < zDimension,
        and VertexTexCoord[i,j] is the texture coordinate for the vertex
            defined by height[i+j×xDimension]

The ccw, solid, and creaseAngle fields are described in 4.6.3, Shapes and geometry.

By default, the quadrilaterals are defined with a counterclockwise ordering. Hence, the Y-component of the normal is positive. Setting the ccw field to FALSE reverses the normal direction. Backface culling is enabled when the solid field is TRUE.

See Figure 6.5 for a depiction of the ElevationGrid node.

#### Figure 6.5 -- ElevationGrid node

## Constructor & Destructor Documentation

ElevationGrid | ( | const char * | name = `""` | ) |

Construct a node with all its fields set to default value, which is equivalent to the code below:

      ccw = true;
      colorPerVertex = true;
      creaseAngle = 0.0f;
      normalPerVertex = true;
      solid = true;
      xDimension = 0;
      xSpacing = 1.0f;
      zDimension = 0;
      zSpacing = 1.0f;

~ElevationGrid | ( |  | ) | `[virtual]`

Virtual destructor, does nothing

## Member Function Documentation

unsigned int nbFields | ( |  | ) | const`[inline, virtual]`

Returns the number of fields (exposed or not) for this node type.

Implements Node.

wrl::Node::FieldHandle field | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the field named `n` of the node or a "unknown" typed handle if there is no such field. Valid names are:

- color
- normal
- texCoord
- height
- ccw
- colorPerVertex
- creaseAngle
- normalPerVertex
- solid
- xDimension
- xSpacing
- zDimension
- zSpacing

Implements Node.

wrl::Node::FieldHandle field | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th field of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : color
- 1 : normal
- 2 : texCoord
- 3 : height
- 4 : ccw
- 5 : colorPerVertex
- 6 : creaseAngle
- 7 : normalPerVertex
- 8 : solid
- 9 : xDimension
- 10 : xSpacing
- 11 : zDimension
- 12 : zSpacing This function is useful, with nbFields() if you want to traverse all fields of a Node.

Implements Node.

bool isSetToDefaultValue | ( | unsigned int | i | ) | const`[virtual]`

Implements Node.

unsigned int nbEventsIn | ( |  | ) | const`[inline, virtual]`

Returns the number of events in for this node type.

Implements Node.

wrl::Node::EventInHandle eventIn | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event in named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- set_height
- set_color
- set_normal
- set_texCoord

Implements Node.

wrl::Node::EventInHandle eventIn | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event in of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : set_height
- 1 : set_color
- 2 : set_normal
- 3 : set_texCoord

This function is useful, with nbEventsIn() if you want to traverse all events in of a Node.

Implements Node.

unsigned int nbEventsOut | ( |  | ) | const`[inline, virtual]`

Returns the number of events out for this node type.

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event out named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- color_changed
- normal_changed
- texCoord_changed

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event out of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : color_changed
- 1 : normal_changed
- 2 : texCoord_changed This function is useful, with nbEventsOut() if you want to traverse all events in of a Node.

Implements Node.

const char * typeName | ( |  | ) | const`[inline, virtual]`

Returns `"ElevationGrid"`. Useful for printing.

Implements Node.

wrl::Node * duplicate | ( |  | ) | const`[virtual]`

Returns a deep copy of this node, that is a fully independant node with all children (if any) also copied. This is mainly useful for instanciating protos.

Implements Node.

virtual Node* duplicate | ( | std::map< const Node *, Node * > & |  | ) | const`[virtual]`

Implements Node.

## Member Data Documentation

SFNode color

See Detailed Description for meaning of this field. Default value is set to SFNode default value

SFNode normal

See Detailed Description for meaning of this field. Default value is set to SFNode default value

SFNode texCoord

See Detailed Description for meaning of this field. Default value is set to SFNode default value

MFFloat height

See Detailed Description for meaning of this field. Default value is set to MFFloat default value

SFBool ccw

See Detailed Description for meaning of this field. Default value is set to

           ccw = true;

SFBool colorPerVertex

See Detailed Description for meaning of this field. Default value is set to

           colorPerVertex = true;

SFFloat creaseAngle

See Detailed Description for meaning of this field. Default value is set to

           creaseAngle = 0.0f;

SFBool normalPerVertex

See Detailed Description for meaning of this field. Default value is set to

           normalPerVertex = true;

SFBool solid

See Detailed Description for meaning of this field. Default value is set to

           solid = true;

SFInt32 xDimension

See Detailed Description for meaning of this field. Default value is set to

           xDimension = 0;

SFFloat xSpacing

See Detailed Description for meaning of this field. Default value is set to

           xSpacing = 1.0f;

SFInt32 zDimension

See Detailed Description for meaning of this field. Default value is set to

           zDimension = 0;

SFFloat zSpacing

See Detailed Description for meaning of this field. Default value is set to

           zSpacing = 1.0f;

EventIn<MFFloat> set_height

See Detailed Description for meaning of this event.

EventIn<SFNode> set_color

Set event associated to exposedField color

EventIn<SFNode> set_normal

Set event associated to exposedField normal

EventIn<SFNode> set_texCoord

Set event associated to exposedField texCoord

EventOut<SFNode> color_changed

Changed event associated to exposedField color

EventOut<SFNode> normal_changed

Changed event associated to exposedField normal

EventOut<SFNode> texCoord_changed

Changed event associated to exposedField texCoord

Generated on 5 Jan 2007 with version 1.5.1. |